# opatech_clearsale_flutter_example

Plugin para fingerprint clear sale.
Esse plugin registra um dispositivo android e ios para obtenção do sessionID, necessário para um envio de order clearsale.
Para utilização do plugin é necessário contrato com a empresa clearsale e 
obtenção do TOKEN para download dos packages android e ios e também Token fingerprint, para a captura dos dados e geração do sessionId.

## Getting Started CONFIG

# Android Config

* Inserir no build.grade de seu projeto. Nível de projeto.
* substituir "Token obtido na clearsale" pelo token informado pela clearsale

```
buildscript {
    repositories {
        ....
        maven {
            url 'https://pkgs.dev.azure.com/vstscs/Produtos-Agile/_packaging/BehaviorAnalytics.SDK/maven/v1'
            name 'BehaviorAnalytics.SDK.Android'
            credentials {
                username "vstscs"
                password "Token obtido na clearsale"
            }
        }
    }
    .....
```

```
 dependencies {
      ....
        classpath 'sale.clear.behavior:sdk-behavior:3.0.2'
    }
```

```
allprojects {
    repositories {
       ...
        maven {
            url 'https://pkgs.dev.azure.com/vstscs/Produtos-Agile/_packaging/BehaviorAnalytics.SDK/maven/v1'
            name 'BehaviorAnalytics.SDK.Android'
            credentials {
                username "vstscs"
                password "Token obtido na clearsale"
            }
        }
.....
```


# IOS config

* Alterar no Podifile do projeto  a  target 'Runner'
e inserir as linhas source e use_frameworks! acima
substituir |Token obtido na clearsale| pelo token informado pela clearsale

```
source	'https://csbehaviorsdk:|Token obtido na clearsale|@dev.azure.com/vstscs/Produtos-Agile/_git/BehaviorAnalytics.SDK.IOS.Specs'
use_frameworks!

target 'Runner' do
  pod 'CSBehavior', '3.0.1'
  flutter_install_all_ios_pods File.dirname(File.realpath(__FILE__))
end
```

* Abrir o project editor, selecionar o projeto, e na aba “Build Settings” adicionar a flag “-ObjC” para a setting “Other Linker Flags”.

* Adicionar as seguintes entradas ao arquivo Info.plist do projeto de destino:
```
<key>NSAppTransportSecurity</key>
<dict>
    <key>NSExceptionDomains</key>
    <dict>
        <key>clearsale.com.br</key>
        <dict>
            <key>NSTemporaryExceptionMinimumTLSVersion</key>
            <string>TLSv1.0</string>
        </dict>
    </dict>
</dict>
```

# Flutter

* obter junto a clear sale o fingerprint e substituir a string "fingerprint fornecido pela clearsale" no código abaixo.

* importar na classe onde vai utilizar a obtencao do sessionId para enviar

```
import 'package:opatech_clearsale_flutter/opatech_clearsale_flutter.dart';
```
* Obter o sessionId

```
String sessionId;
try {
    await OpatechClearsaleFlutter.config("fingerprint fornecido pela clearsale"); // fingerprint id
    sessionId =  await OpatechClearsaleFlutter.sessionId;
} on PlatformException catch (e) {
    sessionId = 'Failed. ${e.message}';
}
```
