package br.com.opabox.clearsale.opatech_clearsale_flutter;

import androidx.annotation.NonNull;

import io.flutter.embedding.engine.plugins.FlutterPlugin;
import io.flutter.plugin.common.MethodCall;
import io.flutter.plugin.common.MethodChannel;
import io.flutter.plugin.common.MethodChannel.MethodCallHandler;
import io.flutter.plugin.common.MethodChannel.Result;
import io.flutter.plugin.common.PluginRegistry.Registrar;
import android.util.Log;
import io.flutter.embedding.engine.plugins.activity.ActivityAware;
import io.flutter.embedding.engine.plugins.activity.ActivityPluginBinding;
import sale.clear.behavior.android.Behavior;
import android.app.Activity;

/** OpatechClearsaleFlutterPlugin */
public class OpatechClearsaleFlutterPlugin implements FlutterPlugin, MethodCallHandler, ActivityAware {
  /// The MethodChannel that will the communication between Flutter and native Android
  ///
  /// This local reference serves to register the plugin with the Flutter Engine and unregister it
  /// when the Flutter Engine is detached from the Activity
  private MethodChannel channel;
  private Behavior mBehavior;
  private String sessionId;
  private String fingerPrint;
  private Activity activity;

  @Override
  public void onAttachedToEngine(@NonNull FlutterPluginBinding flutterPluginBinding) {
    channel = new MethodChannel(flutterPluginBinding.getBinaryMessenger(), "opatech_clearsale_flutter");
    channel.setMethodCallHandler(this);
  }

  @Override
  public void onMethodCall(@NonNull MethodCall call, @NonNull Result result) {
    if (call.method.equals("config")) {
      fingerPrint = call.argument("fingerPrint");
      result.success("success");
    } else if (call.method.equals("getBehaviourSessionId")) {
      try {
        if (sessionId == null) {
          mBehavior = Behavior.getInstance(activity, fingerPrint);
          mBehavior.start();
          sessionId = mBehavior.generateSessionID();
          mBehavior.collectDeviceInformation(sessionId);
          mBehavior.stop();
        }
        result.success(sessionId);
      } catch (Exception e) {
        Log.e("BEHAVIOOUR", e.getMessage());
        result.error("error", e.getMessage(), null);
      }
    } else {
      result.notImplemented();
    }
  }

  @Override
  public void onDetachedFromEngine(@NonNull FlutterPluginBinding binding) {
    channel.setMethodCallHandler(null);
  }

  @Override
  public void onAttachedToActivity(ActivityPluginBinding activityPluginBinding) {
    activity = activityPluginBinding.getActivity();
    Log.d("BEHAVIOOUR"," onAttachedToActivity");
  }

  @Override
  public void onDetachedFromActivityForConfigChanges() {
    Log.d("BEHAVIOOUR"," onDetachedFromActivityForConfigChanges");
  }

  @Override
  public void onReattachedToActivityForConfigChanges(ActivityPluginBinding activityPluginBinding) {
    activity = activityPluginBinding.getActivity();
    Log.d("BEHAVIOOUR"," onReattachedToActivityForConfigChanges");
  }

  @Override
  public void onDetachedFromActivity() {
    Log.d("BEHAVIOOUR","onDetachedFromActivity");
  }
}
